import java.awt.*;
import java.lang.*;
import java.io.*;

	class Herba1Gui extends Frame {
		TextField a1,a2,a3,a4,a5,a6,a7;
		Button c1,c2,c3;
		Label l1,l2,l3,l4,l5,l6,l7;
		Herba1Calculs calcul = null ;
		String nom = "sensenom.dat";
		boolean plot = false;
		boolean eps = false;
		float rx = 2.0f;
		float ry = 2.0f;
		float alfa = 0.75f;
		float beta = 0.75f;
		float x = 0.1f;
		float y = 0.05f;
		int max = 30;

		Herba1Gui(String windowTitle) {
			super(windowTitle);
		}

		public void init() {
			setLayout(new GridLayout(0,2,10,10));
			a1 = new TextField(Float.toString(rx));
			a2 = new TextField(Float.toString(ry));
			a3 = new TextField(Float.toString(alfa));
			a4 = new TextField(Float.toString(beta));
			a5 = new TextField(Float.toString(x));
			a6 = new TextField(Float.toString(y));
			a7 = new TextField(Integer.toString(max));
			c1 = new Button("Calcular");
			c2 = new Button("Guardar");
			c3 = new Button("Sortir");
			l1 = new Label("Parametre rx");
			l2 = new Label("Parametre ry");
			l3 = new Label("Parametre alfa");
			l4 = new Label("Parametre beta");
			l5 = new Label("Parametre x");
			l6 = new Label("Parametre y");
			l7 = new Label("Nombre de passos");
			add(l1);
			add(a1);
			add(l2);
			add(a2);
			add(l3);
			add(a3);
			add(l4);
			add(a4);
			add(l5);
			add(a5);
			add(l6);
			add(a6);
			add(l7);
			add(a7);
			add(c1);
			add(c2);
			add(c3);
			pack();
			c2.disable();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			if(evt.target instanceof TextField)
				return accioCamp((TextField)evt.target);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("Calcular"))
				calcular();
			if(label.equals("Guardar"))
				guardar();
			if(label.equals("Sortir"))
				System.exit(0);
			return true;
		}

		public boolean accioCamp(TextField field) {
			return true;
		}

		public void calcular() {
			Float f1,f2,f3,f4,f5,f6;
			int m;

			f1 = Float.valueOf(a1.getText());
			f2 = Float.valueOf(a2.getText());
			f3 = Float.valueOf(a3.getText());
			f4 = Float.valueOf(a4.getText());
			f5 = Float.valueOf(a5.getText());
			f6 = Float.valueOf(a6.getText());
			rx = f1.floatValue();
			ry = f2.floatValue();
			alfa = f3.floatValue();
			beta = f4.floatValue();
			x = f5.floatValue();
			y = f6.floatValue();
			max = Integer.parseInt(a7.getText());
			calcul = new Herba1Calculs(rx,ry,alfa,beta,x,y,max);
			if(plot) {
				System.out.println("set data style lines");
				System.out.println("plot '-','-'");
				for(m=0;m<max;m++)
					System.out.println(Integer.toString(m) + " " + Double.toString(calcul.trajx[m]));
				System.out.println("e");
				for(m=0;m<max;m++)
					System.out.println(Integer.toString(m) + " " + Double.toString(calcul.trajy[m]));
				System.out.println("e");
			}
			c2.enable();
		}

		public void guardar() {
			File fitxersortida;		// declaraci d'instncies locals
			FileWriter sortida;
			String linia;
			boolean escriure = true;	// declaraci de variables locals
			int k,m;

			try {
				fitxersortida = demanarFitxer();
				if (fitxersortida != null) {
					escriure = !fitxersortida.exists();
					if (!escriure)
						escriure = demanarConfirmacio();
					if(escriure) {
						sortida = new FileWriter(fitxersortida);
						if(eps) {
							sortida.write("set terminal postscript eps color \n");
							sortida.write("set output '"+nom+".eps' \n");
							sortida.write("plot '-' using 1:2 with lines, '-' using 1:3 with lines \n");
						}
						k=0;
						do {
							for(m=0;m<max;m++) {
								linia=Integer.toString(m) + " " + Double.toString(calcul.trajx[m]) + " " + Double.toString(calcul.trajy[m]) + "\n";
								sortida.write(linia);
							}
							if(eps) {
								sortida.write("e \n");
							}
							k++;
						} while((k<2)&&(eps));
						sortida.close();
					}
				}
			} catch (IOException e){}
		}

		public boolean demanarConfirmacio() {
			Herba1DialegConfirmar confirmar = null ;		// declaraci d'instncies locals
			boolean opcio = false;

			if (confirmar == null)
				confirmar = new Herba1DialegConfirmar(this);
			confirmar.show();
			opcio = confirmar.getOpcio();
			return opcio;
		}

		public File demanarFitxer() {
			FileDialog escollirfitxer = null ;	// declaraci d'instncies locals
			File fitxer;
			String nomdirectori = "./";

			fitxer = new File(nomdirectori,nom);
			try {
				escollirfitxer = new FileDialog(this,"Guardar",escollirfitxer.SAVE);
				escollirfitxer.setFile(nom);
				escollirfitxer.show();
				nom = escollirfitxer.getFile();
				nomdirectori = escollirfitxer.getDirectory();
				fitxer = new File(nomdirectori,nom);
			} catch (NullPointerException e) {
				fitxer = null;
				nom = "sensenom.dat";
			}
			return fitxer;
		}

    		public boolean handleEvent(Event evt) {
        		switch (evt.id) {
				case Event.WINDOW_DESTROY:
					System.exit(0);
        		}
        		return super.handleEvent(evt);
    		}
	}

	class Herba1DialegConfirmar extends Dialog {
		Button c1;
		Button c2;
		Label l1;
		boolean opcio = false;

		Herba1DialegConfirmar(Frame progenitora) {
			super(progenitora,"Confirmar",true);
			setLayout(new GridLayout(0,1,10,10));
			c1 = new Button("D'acord");
			c2 = new Button("Cancel.lar");
			l1 = new Label ("  El fitxer ja existeix. Sobreescriure?");
			add(l1);
			add(c1);
			add(c2);
			pack();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("D'acord")) {
				opcio = true;
				hide();
			}
			if(label.equals("Cancel.lar")) {
				opcio = false;
				hide();
			}
			return true;
		}

		public boolean getOpcio() {
		return opcio;
		}
	}

class Herba1 {

	public static void main(String args[]) {
		Herba1Gui herba1 = null;		// Declaraci d'instncies.

		herba1 = new Herba1Gui("Herba1");
		for(int i = 0 ; i < args.length ; i++) {
			if(args[i].equals("-p") || args[i].equals("--gnuplot"))
				herba1.plot = true;
			if(args[i].equals("-e") || args[i].equals("--eps"))
				herba1.eps = true;
		}
		herba1.init();
		herba1.show();
	}
}

