import java.lang.*;

/*
------------------------------------------------------------------------------- 
Equacions de Lotka-Volterra (normalitzades)
-------------------------------------------------------------------------------
Dades: mu (Factor de creixement presa), beta (parametre beta), x (nombre
       inicial de preses), y (nombre inicial de depredadors), max (nombre
       de passos que vols calcular)
Resultats: Fitxer "lotka1.dat". Cada fila representa un instant de temps.
           La primer fila es l'ordinal del pas, la segona el nombre de 
           preses i la tercera el nombre de depredadors
Dades de prova: mu=2.0 beta=0.1 x=0.1 y=0.1 max=2 ==> 0, 0.1, 0.1;
                1, 0.16, 0.002; 2, 0.268160, 0.000064
Observacions: -
-------------------------------------------------------------------------------
*/

public class Lotka1Calculs {
	double mu,beta,x,y,trajx[],trajy[];
	int max;

	Lotka1Calculs(float mu0,float beta0,float x0,float y0,int max0) {
		double xn,yn;
		int n;

		mu = (double) mu0;
		beta = (double) beta0;
		x = (double) x0;
		y = (double) y0;
		max = max0;
		trajx = new double[max];
		trajy = new double[max];

		trajx[0]=x;
		trajy[0]=y;
		for(n=1;n<max;n++) {
			xn=mu*x*(1.0-x-y);
			yn=mu*beta*x*y;
			x=xn;
			y=yn;
			trajx[n]=x;
			trajy[n]=y;
		}
	}
}
