import java.awt.*;
import java.lang.*;
import java.io.*;

	class Lotka3Gui extends Frame {
		TextField a1,a2,a3,a4,a5,a6;
		Button c1,c2,c3;
		Label l1,l2,l3,l4,l5,l6;
		Lotka3Calculs calcul = null ;
		String nom = "sensenom.dat";
		boolean plot = false;
		boolean eps = false;
		float mu = 3.5f;
		float beta = 1.0f;
		float x = 0.1f;
		float y = 0.1f;
		int max = 100;
		int reg = 70;

		Lotka3Gui(String windowTitle) {
			super(windowTitle);
		}

		public void init() {
			setLayout(new GridLayout(0,2,10,10));
			a1 = new TextField(Float.toString(mu));
			a2 = new TextField(Float.toString(beta));
			a3 = new TextField(Float.toString(x));
			a4 = new TextField(Float.toString(y));
			a5 = new TextField(Integer.toString(max));
			a6 = new TextField(Integer.toString(reg));
			c1 = new Button("Calcular");
			c2 = new Button("Guardar");
			c3 = new Button("Sortir");
			l1 = new Label("Parametre Rx");
			l2 = new Label("Parametre beta");
			l3 = new Label("Nombre inicial x");
			l4 = new Label("Nombre inicial y");
			l5 = new Label("Nombre de passos");
			l6 = new Label("Registrar a partir de");
			add(l1);
			add(a1);
			add(l2);
			add(a2);
			add(l3);
			add(a3);
			add(l4);
			add(a4);
			add(l5);
			add(a5);
			add(l6);
			add(a6);
			add(c1);
			add(c2);
			add(c3);
			pack();
			c2.disable();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			if(evt.target instanceof TextField)
				return accioCamp((TextField)evt.target);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("Calcular"))
				calcular();
			if(label.equals("Guardar"))
				guardar();
			if(label.equals("Sortir"))
				System.exit(0);
			return true;
		}

		public boolean accioCamp(TextField field) {
			return true;
		}

		public void calcular() {
			Float f1,f2,f3,f4;
			int m;

			f1 = Float.valueOf(a1.getText());
			f2 = Float.valueOf(a2.getText());
			f3 = Float.valueOf(a3.getText());
			f4 = Float.valueOf(a4.getText());
			mu = f1.floatValue();
			beta = f2.floatValue();
			x = f3.floatValue();
			y = f4.floatValue();
			max = Integer.parseInt(a5.getText());
			reg = Integer.parseInt(a6.getText());
			calcul = new Lotka3Calculs(mu,beta,x,y,max,reg);
			if(plot) {
				System.out.println("set data style lines");
				System.out.println("plot '-'");
				for(m=reg+1;m<max;m++)
					System.out.println(Double.toString(calcul.trajx[m]) + " " + Double.toString(calcul.trajy[m]));
				System.out.println("e");
			}
			c2.enable();
		}

		public void guardar() {
			File fitxersortida;		// declaraci d'instncies locals
			FileWriter sortida;
			String linia;
			boolean escriure = true;	// declaraci de variables locals
			int m;

			try {
				fitxersortida = demanarFitxer();
				if (fitxersortida != null) {
					escriure = !fitxersortida.exists();
					if (!escriure)
						escriure = demanarConfirmacio();
					if(escriure) {
						sortida = new FileWriter(fitxersortida);
						if(eps) {
							sortida.write("set terminal postscript eps color \n");
							sortida.write("set output '"+nom+".eps' \n");
							sortida.write("plot '-' using 2:3 with lines \n");
						}
						for(m=reg+1;m<max;m++) {
							linia=Integer.toString(m) + " " + Double.toString(calcul.trajx[m]) + " " + Double.toString(calcul.trajy[m]) + "\n";
							sortida.write(linia);
						}
						if(eps) {
							sortida.write("e \n");
						}
						sortida.close();
					}
				}
			} catch (IOException e){}
		}

		public boolean demanarConfirmacio() {
			Lotka3DialegConfirmar confirmar = null ;		// declaraci d'instncies locals
			boolean opcio = false;

			if (confirmar == null)
				confirmar = new Lotka3DialegConfirmar(this);
			confirmar.show();
			opcio = confirmar.getOpcio();
			return opcio;
		}

		public File demanarFitxer() {
			FileDialog escollirfitxer = null ;	// declaraci d'instncies locals
			File fitxer;
			String nomdirectori = "./";

			fitxer = new File(nomdirectori,nom);
			try {
				escollirfitxer = new FileDialog(this,"Guardar",escollirfitxer.SAVE);
				escollirfitxer.setFile(nom);
				escollirfitxer.show();
				nom = escollirfitxer.getFile();
				nomdirectori = escollirfitxer.getDirectory();
				fitxer = new File(nomdirectori,nom);
			} catch (NullPointerException e) {
				fitxer = null;
				nom = "sensenom.dat";
			}
			return fitxer;
		}

    		public boolean handleEvent(Event evt) {
        		switch (evt.id) {
				case Event.WINDOW_DESTROY:
					System.exit(0);
        		}
        		return super.handleEvent(evt);
    		}
	}

	class Lotka3DialegConfirmar extends Dialog {
		Button c1;
		Button c2;
		Label l1;
		boolean opcio = false;

		Lotka3DialegConfirmar(Frame progenitora) {
			super(progenitora,"Confirmar",true);
			setLayout(new GridLayout(0,1,10,10));
			c1 = new Button("D'acord");
			c2 = new Button("Cancel.lar");
			l1 = new Label ("  El fitxer ja existeix. Sobreescriure?");
			add(l1);
			add(c1);
			add(c2);
			pack();
		}

		public boolean action(Event evt,Object arg) {
			if(evt.target instanceof Button)
				return accioBoto((String)arg);
			return true;
		}

		public boolean accioBoto(String label) {
			if(label.equals("D'acord")) {
				opcio = true;
				hide();
			}
			if(label.equals("Cancel.lar")) {
				opcio = false;
				hide();
			}
			return true;
		}

		public boolean getOpcio() {
		return opcio;
		}
	}

class Lotka3 {

	public static void main(String args[]) {
		Lotka3Gui lotka3 = null;		// Declaraci d'instncies.

		lotka3 = new Lotka3Gui("Lotka3");
		for(int i = 0 ; i < args.length ; i++) {
			if(args[i].equals("-p") || args[i].equals("--gnuplot"))
				lotka3.plot = true;
			if(args[i].equals("-e") || args[i].equals("--eps"))
				lotka3.eps = true;
		}
		lotka3.init();
		lotka3.show();
	}
}

